﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace lovci
{
    public partial class Form1 : Form
    {
        string[,] map;
        int player1posX, player1posY, player2posX,player2posY;
        int base1posX, base1posY, base2posX, base2posY;
        bool hrajeHrac1 = true;
        
        public Form1()
        {
            InitializeComponent();            
            
            createMap(10, 10, true);

            //inPB("test", 10, 30, 70, 50);
            /*String name = "p10_10";
            PictureBox ctn = this.Controls.Find(name, true).FirstOrDefault() as PictureBox;
            ctn.Image = global::lovci.Properties.Resources.empty;//*/
        }

        public void createMap(int width, int height, bool secondPlayer)
        {
            map = new String[width, height];
            pattern(64, 64, 8, 10, 10);

            Random rnd = new Random();
            player1posX = rnd.Next(0, width);
            player1posY = rnd.Next(0, height);
            base1posX = player1posX;
            base1posY = player1posY;
            map[player1posX, player1posY] = "++";
            PictureBox pbBase1 = this.Controls.Find("p" + (player1posX + 1) + "_" + (player1posY + 1), true).FirstOrDefault() as PictureBox;
            pbBase1.Image = global::lovci.Properties.Resources.lovec1Tah;

            if (secondPlayer)
                {
                    player2posX = rnd.Next(0, width);
                    player2posY = rnd.Next(0, height);
                    base2posX = player2posX;
                    base2posY = player2posY;
                    map[player2posX, player2posY] = "--";
                    PictureBox pbBase2 = this.Controls.Find("p" + (player2posX + 1) + "_" + (player2posY + 1), true).FirstOrDefault() as PictureBox;
                    pbBase2.Image = global::lovci.Properties.Resources.lovec2;
                }

            for (int y = 1; y <= height; y++)
            {
                for (int x = 1; x <= width; x++)
                {
                    if (map[x-1, y -1] == null)
                    {
                        PictureBox pb = this.Controls.Find("p" + x + "_" + y, true).FirstOrDefault() as PictureBox;
                        switch (rnd.Next(0, 10))
                        {
                            case 1:
                                map[x - 1, y - 1] = "XX";
                                pb.Image = global::lovci.Properties.Resources.zed;
                                break;
                            case 2:
                                int poklad = rnd.Next(0, 100);
                                map[x - 1, y - 1] = "p" + poklad.ToString();
                                pb.Paint += new PaintEventHandler((sender, e) =>
                                {
                                    e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.ClearTypeGridFit;

                                    string text = poklad.ToString();

                                    Font myFont = new Font("Arial", pb.Height/2);
                                    SizeF textSize = e.Graphics.MeasureString(text, myFont);
                                    PointF locationToDraw = new PointF();
                                    locationToDraw.X = (pb.Width / 2) - (textSize.Width / 2);
                                    locationToDraw.Y = (pb.Height / 2) - (textSize.Height / 2);

                                    
                                    e.Graphics.DrawString(text, myFont, Brushes.Gold, locationToDraw);
                                });
                                    break;
                            default: map[x - 1, y - 1] = ".."; break;
                        }
                    }
                    
                    
                    
                }
            }
        }
        
        public void inPB(string name, int x,int y, int width, int heigh)
        {
            PictureBox p = new PictureBox();
            p.Name = name;
            p.Location = new System.Drawing.Point(x,y);
            p.Size = new System.Drawing.Size(width, heigh);
            p.Image = global::lovci.Properties.Resources.empty;
            p.Click += new System.EventHandler(this.pictureBox_Click);
            this.Controls.Add(p);
        }

        public void pattern(int width, int height, int space, int xNum, int yNum)
        {
            for (int y = 1; y <= yNum; y++)
            {
                for (int x = 1; x <= xNum; x++)
                {
                    inPB("p" + x + "_" + y, space * x + width * (x - 1), space * y + height * (y - 1), width, height);
                }
            }
            this.ClientSize = new Size(space * (xNum + 1) + width * xNum, space * (yNum + 1) + height * yNum);
        }

        private void pictureBox_Click(object sender, EventArgs e)
        {
            string[] s = nameToPos(((PictureBox)sender).Name);
            int cPosX = Int32.Parse(s[0]);
            int cPosY = Int32.Parse(s[1]);
            
            if (hrajeHrac1)
            {
                if (player1posX == cPosX && player1posY == cPosY + 1) move(cPosX, cPosY);
                if (player1posX == cPosX && player1posY == cPosY - 1) move(cPosX, cPosY);
                if (player1posX == cPosX + 1 && player1posY == cPosY) move(cPosX, cPosY);
                if (player1posX == cPosX - 1 && player1posY == cPosY) move(cPosX, cPosY);
            }
            else
            {
                if (player2posX == cPosX && player2posY == cPosY + 1) move(cPosX, cPosY);
                if (player2posX == cPosX && player2posY == cPosY - 1) move(cPosX, cPosY);
                if (player2posX == cPosX + 1 && player2posY == cPosY) move(cPosX, cPosY);
                if (player2posX == cPosX - 1 && player2posY == cPosY) move(cPosX, cPosY);           
            }
        }

        public void move(int x, int y)
        {
            if (map[x, y] == ".." || map[x, y][0] == 'p')
            {
                if (hrajeHrac1)
                {
                    if (player1posX == base1posX && player1posY == base1posY)
                    {
                        PictureBox ctn1 = this.Controls.Find("p" + (player1posX+1) +"_"+ (player1posY+1), true).FirstOrDefault() as PictureBox;
                        ctn1.Image = global::lovci.Properties.Resources.zaklada1;
                    }
                    
                    PictureBox ctn2 = this.Controls.Find("p" + (x+1) + "_" + (y+1), true).FirstOrDefault() as PictureBox;
                    ctn2.Image = global::lovci.Properties.Resources.lovec1;
                    
                    player1posX = x;
                    player1posY = y;
                }
                else
                {
                    if (player2posX == base2posX && player2posY == base2posY)
                    {
                        PictureBox ctn1 = this.Controls.Find("p" + (player2posX + 1) + "_" + (player2posY + 1), true).FirstOrDefault() as PictureBox;
                        ctn1.Image = global::lovci.Properties.Resources.zaklada2;
                    }

                    PictureBox ctn2 = this.Controls.Find("p" + (x + 1) + "_" + (y + 1), true).FirstOrDefault() as PictureBox;
                    ctn2.Image = global::lovci.Properties.Resources.lovec2;

                    player2posX = x;
                    player2posY = y;
                }

                hrajeHrac1 = !hrajeHrac1;
            }
        }

        public string[] nameToPos(string name)
        {
            int num = 0;
            string[] rtn = new string[2]; 
            foreach (char c in name)
            {
                if (c != 'p')
                {
                    if (Char.IsNumber(c))
                        rtn[num] += c;
                    else
                        num++;
                }
            }
                return rtn;
        }
    }
}
